
-------------------------------
-- Tajifun's Building Script --		
-------------------------------


--[[

[F2] - Brushmenu
[F3] - Buildingmenu
[F4] - Turn Brushes on/off

Press E to "draw".


I hope you like it. :)

]]


ADMINS = {12345,54321,8529,61226} -- Add Admins here!


-- Settings --

building_weapon = 74
-- Weapon which allows to use the build function (default: 74 [Knife])

updaterate = 30
-- Updaterate of the images in ms (default: 30)




-- BRUSH TABLE --
-- You can edit them if you want :p

TABLE = {
	[1] = {
		num = 1, -- Number of Brushfields
		x = {
			[1] = 0, -- Brushfield 1 x offset
		},
		y = {
			[1] = 0, -- Brushfield 1 y offset
		},
	},
	[2] = {
		num = 5,
		x = {
			[1] = 0,
			[2] = -32,
			[3] = 32,
			[4] = 0,
			[5] = 0,
		},
		y = {
			[1] = 0,
			[2] = 0,
			[3] = 0,
			[4] = 32,
			[5] = -32,
		},
	},
	[3] = {
		num = 9,
		x = {
			[1] = 0,
			[2] = -32,
			[3] = 32,
			[4] = 0,
			[5] = 0,
			[6] = -32,
			[7] = 32,
			[8] = -32,
			[9] = 32,
		},
		y = {
			[1] = 0,
			[2] = 0,
			[3] = 0,
			[4] = 32,
			[5] = -32,
			[6] = -32,
			[7] = -32,
			[8] = 32,
			[9] = 32,
		},
	},
	[4] = {
		num = 8,
		x = {
			[1] = -32,
			[2] = 32,
			[3] = 0,
			[4] = 0,
			[5] = -32,
			[6] = 32,
			[7] = -32,
			[8] = 32,
		},
		y = {
			[1] = 0,
			[2] = 0,
			[3] = 32,
			[4] = -32,
			[5] = -32,
			[6] = -32,
			[7] = 32,
			[8] = 32,
		},
	},
	[5] = {
		num = 3,
		x = {
			[1] = -32,
			[2] = 0,
			[3] = 32,
		},
		y = {
			[1] = 0,
			[2] = 0,
			[3] = 0,
		},
	},
	[6] = {
		num = 3,
		x = {
			[1] = 0,
			[2] = 0,
			[3] = 0,
		},
		y = {
			[1] = -32,
			[2] = 0,
			[3] = 32,
		},
	},
	[7] = {
		num = 5,
		x = {
			[1] = -64,
			[2] = -32,
			[3] = 0,
			[4] = 32,
			[5] = 64,
		},
		y = {
			[1] = 0,
			[2] = 0,
			[3] = 0,
			[4] = 0,
			[5] = 0,
		},
	},
	[8] = {
		num = 5,
		x = {
			[1] = 0,
			[2] = 0,
			[3] = 0,
			[4] = 0,
			[5] = 0,
		},
		y = {
			[1] = -64,
			[2] = -32,
			[3] = 0,
			[4] = 32,
			[5] = 64,
		},
	},
	[9] = {
		num = math.random(2,7),
		x = {
			[1] = math.random(-3,3)*32,
			[2] = math.random(-3,3)*32,
			[3] = math.random(-3,3)*32,
			[4] = math.random(-3,3)*32,
			[5] = math.random(-3,3)*32,
			[6] = math.random(-3,3)*32,
			[7] = math.random(-3,3)*32,
			[8] = math.random(-3,3)*32,
			[9] = math.random(-3,3)*32,
		},
		y = {
			[1] = math.random(-3,3)*32,
			[2] = math.random(-3,3)*32,
			[3] = math.random(-3,3)*32,
			[4] = math.random(-3,3)*32,
			[5] = math.random(-3,3)*32,
			[6] = math.random(-3,3)*32,
			[7] = math.random(-3,3)*32,
			[8] = math.random(-3,3)*32,
			[9] = math.random(-3,3)*32,
		},
	},
}


function initArray(m,v)
	local array = {}
	for i = 1, m do
		array[i] = v or 0
	end
	return array
end

function doubleArray(m,n,k)
    local a, x, y = {}
    for x = 0, m do a[x] = {}
        for y = 0, n do
            a[x][y] = k or 0
        end
    end
    return a
end

function math.tile(var)
	_ = math.ceil(var/32)
	return _
end

function math.pix(var,middle)
	if middle then
		_ = var * 32 - 16
	else
		_ = var * 32
	end
	return _
end


-- Arrays
t = doubleArray(32,9)
atktype = initArray(32,1)
btype = initArray(32,5)
mode_on = initArray(32,1)


function brushmenu(id)
	menu(id,"Brush Menu,Brush 1|"..TABLE[1].num.." Blocks,Brush 2|"..TABLE[2].num.." Blocks,Brush 3|"..TABLE[3].num.." Blocks,Brush 4|"..TABLE[4].num.." Blocks,Brush 5| "..TABLE[5].num.." Blocks,Brush 6|"..TABLE[6].num.." Blocks,Brush 7|"..TABLE[7].num.." Blocks,Brush 8|"..TABLE[8].num.." Blocks,Brush 9|Random Blocks")	
end

function buildingmenu(id)
	menu(id,"Building Menu,Wall I,Wall II,Wall III,Turret,Dual Turret,Triple Turret,Dispenser,Supply,Gatefield")	
end

function isAdmin(id)
	for i = 1, #ADMINS do
		if player(id,"usgn") == ADMINS[i] then
			return 1
		end
	end
end



timer(updaterate,"requestdata","",0)

function setup()
	for i=1,32 do
		if atktype[i] == 1 then
			for o = 1, TABLE[1].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 2 then
			for o = 1, TABLE[2].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 3 then
			for o = 1, TABLE[3].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 4 then
			for o = 1, TABLE[4].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 5 then
			for o = 1, TABLE[5].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 6 then
			for o = 1, TABLE[6].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 7 then
			for o = 1, TABLE[7].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 8 then
			for o = 1, TABLE[8].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
		if atktype[i] == 9 then
			for o = 1, TABLE[9].num do
				t[i][o] = image("gfx/hud_buildhelper.png",-10000,-10000,3,i)
				imagecolor(t[i][o],255,0,0)
				imageblend(t[i][o],1)
				imagealpha(t[i][o],0.42)
			end
		end
	end
end

setup()


addhook("startround","funcstartround")
function funcstartround()
	for id = 1 ,32 do
		if mode_on[id] == 1 then
			setup()
		end 
	end
end


function requestdata()
	reqcld(0,2)
end


addhook("clientdata","funcclientdata")
function funcclientdata(id,mode,x,y)
	if (mode==2) then
		if mode_on[id] == 1 then
			if player(id,"bot")==false then
					
				x = math.tile(x)
				px = math.pix(x,1)
				tilex = math.tile(px) -1
				y = math.tile(y)
				py = math.pix(y,1)
				tiley = math.tile(py) -1
				
				if atktype[id] == 1 then
					for o = 1, TABLE[1].num do
						tween_move(t[id][o],30,px+TABLE[1].x[o],py+TABLE[1].y[o])
					end
				end
				if atktype[id] == 2 then
					for o = 1, TABLE[2].num do
						tween_move(t[id][o],30,px+TABLE[2].x[o],py+TABLE[2].y[o])
					end
				end	
				if atktype[id] == 3 then
					for o = 1, TABLE[3].num do
						tween_move(t[id][o],30,px+TABLE[3].x[o],py+TABLE[3].y[o])
					end
				end	
				if atktype[id] == 4 then
					for o = 1, TABLE[4].num do
						tween_move(t[id][o],30,px+TABLE[4].x[o],py+TABLE[4].y[o])
					end
				end	
				if atktype[id] == 5 then
					for o = 1, TABLE[5].num do
						tween_move(t[id][o],30,px+TABLE[5].x[o],py+TABLE[5].y[o])
					end
				end	
				if atktype[id] == 6 then
					for o = 1, TABLE[6].num do
						tween_move(t[id][o],30,px+TABLE[6].x[o],py+TABLE[6].y[o])
					end
				end	
				if atktype[id] == 7 then
					for o = 1, TABLE[7].num do
						tween_move(t[id][o],30,px+TABLE[7].x[o],py+TABLE[7].y[o])
					end
				end	
				if atktype[id] == 8 then
					for o = 1, TABLE[8].num do
						tween_move(t[id][o],30,px+TABLE[8].x[o],py+TABLE[8].y[o])
					end
				end	
				if atktype[id] == 9 then
					for o = 1, TABLE[9].num do
						tween_move(t[id][o],30,px+TABLE[9].x[o],py+TABLE[9].y[o])
					end
				end					
			end
		end
	end
end


addhook("use","funcuse")
function funcuse(id)
	if isAdmin(id) == 1 then
		if mode_on[id] == 1 then
			if player(id,"weapon") == building_weapon then
				for o = 1, TABLE[atktype[id]].num do
					if tile(tilex+(math.tile(TABLE[atktype[id]].x[o])),tiley+(math.tile(TABLE[atktype[id]].y[o])),"wall") == false then
						if tile(tilex+(math.tile(TABLE[atktype[id]].x[o])),tiley+(math.tile(TABLE[atktype[id]].y[o])),"obstacle") == false then
							parse("spawnobject "..btype[id].." "..tilex+(math.tile(TABLE[atktype[id]].x[o])).." "..tiley+(math.tile(TABLE[atktype[id]].y[o])).." 0 0 "..player(id,"team").." "..id.."")
						end
					end
				end
			else
				msg2(id,"You need a Wrench to build something.")
			end
		end
	else
		msg2(id,"255000000You need to be admin!")
	end
end


addhook("menu","funcmenu")
function funcmenu(id,menu,sel)
	if menu == "Brush Menu" then
		if mode_on[id] == 1 then
			if sel == 1 then
				atktype[id] = 1
			end
			if sel == 2 then
				atktype[id] = 2
			end
			if sel == 3 then
				atktype[id] = 3
			end
			if sel == 4 then
				atktype[id] = 4
			end
			if sel == 5 then
				atktype[id] = 5
			end
			if sel == 6 then
				atktype[id] = 6
			end
			if sel == 7 then
				atktype[id] = 7
			end
			if sel == 8 then
				atktype[id] = 8
			end
			if sel == 9 then
				atktype[id] = 9
				for o = 1, TABLE[9].num do
					TABLE[9].x[o] = math.random(-3,3)*32
					TABLE[9].y[o] = math.random(-3,3)*32		
				end
				TABLE[9].num = math.random(3,7)
			end
			
			for i = 1, 9 do
				freeimage(t[id][i])
			end
			setup()
			imagepos(t[id][1],px,py,0)
			imagepos(t[id][2],px,py,0)
			imagepos(t[id][3],px,py,0)
			imagepos(t[id][4],px,py,0)
			imagepos(t[id][5],px,py,0)
			imagepos(t[id][6],px,py,0)
			imagepos(t[id][7],px,py,0)
			imagepos(t[id][8],px,py,0)
			imagepos(t[id][9],px,py,0)
		else
			msg2(id,"255000000You need to turn your brush on! (F3)")
		end
	end
	if menu == "Building Menu" then
		if mode_on[id] == 1 then
			if sel == 1 then
				btype[id] = 3
			end
			if sel == 2 then
				btype[id] = 4
			end
			if sel == 3 then
				btype[id] = 5
			end
			if sel == 4 then
				btype[id] = 8
			end
			if sel == 5 then
				btype[id] = 11
			end
			if sel == 6 then
				btype[id] = 12
			end
			if sel == 7 then
				btype[id] = 7
			end
			if sel == 8 then
				btype[id] = 9
			end
			if sel == 9 then
				btype[id] = 6
			end
		else
			msg2(id,"255000000You need to turn your brush on! (F3)")
		end
	end
end




addhook("serveraction","funcserveraction")
function funcserveraction(id,key)
	if key == 1 then
		brushmenu(id)
	end
	if key == 2 then
		buildingmenu(id)
	end
	if key == 3 then
		if mode_on[id] == 0 then
			mode_on[id] = 1
			--[[for i = 1, 9 do
				freeimage(t[id][i])
			end
			setup()
			imagepos(t[id][1],px,py,0)
			imagepos(t[id][2],px,py,0)
			imagepos(t[id][3],px,py,0)
			imagepos(t[id][4],px,py,0)
			imagepos(t[id][5],px,py,0)
			imagepos(t[id][6],px,py,0)
			imagepos(t[id][7],px,py,0)
			imagepos(t[id][8],px,py,0)
			imagepos(t[id][9],px,py,0)]]
			for i = 1, 9 do
				tween_alpha(t[id][i],2100,0.42)
			end
		elseif mode_on[id] == 1 then
			for i = 1, 9 do
				--freeimage(t[id][i])
				tween_alpha(t[id][i],1250,0.0)
			end
			mode_on[id] = 0
		end
	end
end


print("000255000Tajifun's Building Script installed succesfully!")